diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/__init__.py
index fdf72d73d..28420fa9e 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/__init__.py
@@ -547,7 +547,13 @@ def create(self, gid, sid, did, scid, tid):
         )
 
         for k, v in data.items():
-            data[k] = json.loads(v, encoding='utf-8', cls=ColParamsJSONDecoder)
+            # comments should be taken as is because if user enters a
+            # json comment it is parsed by loads which should not happen
+            if k in ('description',):
+                data[k] = v
+            else:
+                data[k] = json.loads(v, encoding='utf-8',
+                                     cls=ColParamsJSONDecoder)
 
         required_args = {
             'name': 'Name',
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/test_column_add.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/test_column_add.py
index bb92cfb77..756fb510c 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/test_column_add.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/test_column_add.py
@@ -25,31 +25,83 @@
 class ColumnAddTestCase(BaseTestGenerator):
     """This class will add new column under table node."""
     scenarios = [
-        ('Add column', dict(url='/browser/column/obj/')),
-        ('Add column with Identity', dict(url='/browser/column/obj/',
-                                          server_min_version=100000,
-                                          identity_opt={
-                                              'cltype': 'bigint',
-                                              'attidentity': 'a',
-                                              'seqincrement': 1,
-                                              'seqstart': 1,
-                                              'seqmin': 1,
-                                              'seqmax': 10,
-                                              'seqcache': 1,
-                                              'seqcycle': True
-                                          })),
-        ('Add column with Identity', dict(url='/browser/column/obj/',
-                                          server_min_version=100000,
-                                          identity_opt={
-                                              'cltype': 'bigint',
-                                              'attidentity': 'd',
-                                              'seqincrement': 2,
-                                              'seqstart': 2,
-                                              'seqmin': 2,
-                                              'seqmax': 2000,
-                                              'seqcache': 1,
-                                              'seqcycle': True
-                                          }))
+        ('Add column', dict(
+            url='/browser/column/obj/',
+            data={
+                'cltype': "\"char\"",
+                'attacl': [],
+                'is_primary_key': False,
+                'attnotnull': False,
+                'attlen': None,
+                'attprecision': None,
+                'attoptions':[],
+                'seclabels':[],
+            })),
+        ('Add Identity column with Always', dict(
+            url='/browser/column/obj/',
+            server_min_version=100000,
+            skip_msg='Identity column are not supported by EPAS/PG 10.0 '
+                     'and below.',
+            data={
+                'cltype': 'bigint',
+                'attacl': [],
+                'is_primary_key': False,
+                'attnotnull': True,
+                'attlen': None,
+                'attprecision': None,
+                'attoptions': [],
+                'seclabels': [],
+                'colconstype': 'i',
+                'attidentity': 'a',
+                'seqincrement': 1,
+                'seqstart': 1,
+                'seqmin': 1,
+                'seqmax': 10,
+                'seqcache': 1,
+                'seqcycle': True
+            })),
+        ('Add Identity column with As Default', dict(
+            url='/browser/column/obj/',
+            col_data_type='bigint',
+            server_min_version=100000,
+            skip_msg='Identity column are not supported by EPAS/PG 10.0 '
+                     'and below.',
+            data={
+                'cltype': 'bigint',
+                'attacl': [],
+                'is_primary_key': False,
+                'attnotnull': True,
+                'attlen': None,
+                'attprecision': None,
+                'attoptions': [],
+                'seclabels': [],
+                'colconstype': 'i',
+                'attidentity': 'd',
+                'seqincrement': 2,
+                'seqstart': 2,
+                'seqmin': 2,
+                'seqmax': 2000,
+                'seqcache': 1,
+                'seqcycle': True
+            })),
+        ('Add Generated column', dict(
+            url='/browser/column/obj/',
+            col_data_type='bigint',
+            server_min_version=120000,
+            skip_msg='Generated column are not supported by EPAS/PG 12.0 '
+                     'and below.',
+            data={
+                'cltype': 'bigint',
+                'attacl': [],
+                'is_primary_key': False,
+                'attnotnull': True,
+                'attlen': None,
+                'attprecision': None,
+                'attoptions': [],
+                'seclabels': [],
+                'colconstype': 'g',
+                'genexpr': '100 * 100'
+            })),
     ]
 
     def setUp(self):
@@ -64,9 +116,7 @@ def setUp(self):
                 raise Exception("Could not connect to server to add "
                                 "a table.")
             if server_con["data"]["version"] < self.server_min_version:
-                message = "Identity columns are not supported by " \
-                          "PPAS/PG 10.0 and below."
-                self.skipTest(message)
+                self.skipTest(self.skip_msg)
 
         db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
                                                  self.server_id, self.db_id)
@@ -87,26 +137,16 @@ def setUp(self):
     def runTest(self):
         """This function will add column under table node."""
         self.column_name = "test_column_add_%s" % (str(uuid.uuid4())[1:8])
-        data = {
-            "name": self.column_name,
-            "cltype": "\"char\"",
-            "attacl": [],
-            "is_primary_key": False,
-            "attnotnull": False,
-            "attlen": None,
-            "attprecision": None,
-            "attoptions": [],
-            "seclabels": []
-        }
+        self.data.update({
+            'name': self.column_name
+        })
 
-        if hasattr(self, 'identity_opt'):
-            data.update(self.identity_opt)
         # Add table
         response = self.tester.post(
             self.url + str(utils.SERVER_GROUP) + '/' +
             str(self.server_id) + '/' + str(self.db_id) +
             '/' + str(self.schema_id) + '/' + str(self.table_id) + '/',
-            data=json.dumps(data),
+            data=json.dumps(self.data),
             content_type='html/json')
         self.assertEquals(response.status_code, 200)
 
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/utils.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/utils.py
index e013699f4..27f9a4300 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/utils.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/utils.py
@@ -63,6 +63,55 @@ def create_column(server, db_name, schema_name, table_name, col_name,
         raise
 
 
+def create_identity_column(server, db_name, schema_name, table_name,
+                           col_name, col_data_type='bigint'):
+    """
+    This function creates a column under provided table.
+    :param server: server details
+    :type server: dict
+    :param db_name: database name
+    :type db_name: str
+    :param schema_name: schema name
+    :type schema_name: str
+    :param table_name: table name
+    :type table_name: str
+    :param col_name: column name
+    :type col_name: str
+    :param col_data_type: column data type
+    :type col_data_type: str
+    :return table_id: table id
+    :rtype: int
+    """
+    try:
+        connection = utils.get_db_connection(db_name,
+                                             server['username'],
+                                             server['db_password'],
+                                             server['host'],
+                                             server['port'],
+                                             server['sslmode'])
+        old_isolation_level = connection.isolation_level
+        connection.set_isolation_level(0)
+        pg_cursor = connection.cursor()
+        query = "ALTER TABLE %s.%s ADD COLUMN %s %s " \
+                "GENERATED ALWAYS AS IDENTITY" % \
+                (schema_name, table_name, col_name, col_data_type)
+        pg_cursor.execute(query)
+        connection.set_isolation_level(old_isolation_level)
+        connection.commit()
+        # Get column position of newly added column
+        pg_cursor.execute("select attnum from pg_attribute where"
+                          " attname='%s'" % col_name)
+        col = pg_cursor.fetchone()
+        col_pos = ''
+        if col:
+            col_pos = col[0]
+        connection.close()
+        return col_pos
+    except Exception:
+        traceback.print_exc(file=sys.stderr)
+        raise
+
+
 def verify_column(server, db_name, col_name):
     """
     This function verifies table exist in database or not.
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/tests/utils.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/tests/utils.py
index 51dd5d98c..148e15cfe 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/tests/utils.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/tests/utils.py
@@ -242,3 +242,81 @@ def set_partition_data(server, db_name, schema_name, table_name,
                         }]
              }
         )
+
+
+def get_table_common_data():
+    """
+    This function will return the common data used to create a table
+    :return:
+    """
+    return {
+        "check_constraint": [],
+        "coll_inherits": "[]",
+        "columns": [{
+            "name": "empno",
+            "cltype": "numeric",
+            "attacl": [],
+            "is_primary_key": False,
+            "attoptions": [],
+            "seclabels": []
+        }, {
+            "name": "empname",
+            "cltype": "character[]",
+            "attacl": [],
+            "is_primary_key": False,
+            "attoptions": [],
+            "seclabels": []
+        }, {
+            "name": "DOJ",
+            "cltype": "date",
+            "attacl": [],
+            "is_primary_key": False,
+            "attoptions": [],
+            "seclabels": []
+        }],
+        "exclude_constraint": [],
+        "fillfactor": "",
+        "hastoasttable": True,
+        "like_constraints": True,
+        "like_default_value": True,
+        "like_relation": "pg_catalog.pg_namespace",
+        "primary_key": [],
+        "relhasoids": True,
+        "seclabels": [],
+        "spcname": "pg_default",
+        "unique_constraint": [],
+        "vacuum_table": [{
+            "name": "autovacuum_analyze_scale_factor"
+        }, {
+            "name": "autovacuum_analyze_threshold"
+        }, {
+            "name": "autovacuum_freeze_max_age"
+        }, {
+            "name": "autovacuum_vacuum_cost_delay"
+        }, {
+            "name": "autovacuum_vacuum_cost_limit"
+        }, {
+            "name": "autovacuum_vacuum_scale_factor"
+        }, {
+            "name": "autovacuum_vacuum_threshold"
+        }, {
+            "name": "autovacuum_freeze_min_age"
+        }, {
+            "name": "autovacuum_freeze_table_age"
+        }],
+        "vacuum_toast": [{
+            "name": "autovacuum_freeze_max_age"
+        }, {
+            "name": "autovacuum_vacuum_cost_delay"
+        }, {
+            "name": "autovacuum_vacuum_cost_limit"
+        }, {
+            "name": "autovacuum_vacuum_scale_factor"
+        }, {
+            "name": "autovacuum_vacuum_threshold"
+        }, {
+            "name": "autovacuum_freeze_min_age"
+        }, {
+            "name": "autovacuum_freeze_table_age"
+        }]
+    }
#diff --git a/web/pgadmin/static/js/backform.pgadmin.js b/web/pgadmin/static/js/backform.pgadmin.js
#index 012a7432b..8e69cfb81 100644
#--- a/web/pgadmin/static/js/backform.pgadmin.js
#+++ b/web/pgadmin/static/js/backform.pgadmin.js
#@@ -448,11 +448,11 @@ define([
#     template: _.template([
#       '<label class="<%=controlLabelClassName%>"><%=label%></label>',
#       '<div class="<%=controlsClassName%> <%=extraClasses.join(\' \')%>">',
#-      ' <div class="btn-group pgadmin-controls-radio-none"  data-toggle="buttons">',
#+      ' <div class="btn-group pgadmin-controls-radio-none<% if (disabled) {%> disabled <%}%>"  data-toggle="buttons">',
#       '  <% for (var i=0; i < options.length; i++) { %>',
#       '  <% var option = options[i]; %>',
#-      '  <label class="btn btn-primary<% if (option.value == value) { %> active<%}%>" tabindex="0">',
#-      '   <input type="radio" name="<%=name%>" autocomplete="off" value=<%-formatter.fromRaw(option.value)%> <% if (option.value == value) { %> checked<%}%> > <%-option.label%>',
#+      '  <label class="btn btn-primary<% if (option.value == value) { %> active<%}%><% if (!option.disabled && !disabled) { %>" tabindex="0"<% } else { %> disabled"<% } %>>',
#+      '   <input type="radio" name="<%=name%>" autocomplete="off" value=<%-formatter.fromRaw(option.value)%> <% if (option.value == value) { %> checked<%}%> <% if (option.disabled || disabled) { %> disabled <%}%>> <%-option.label%>',
#       '  </label>',
#       '  <% } %>',
#       ' </div>',
#@@ -466,7 +466,37 @@ define([
#       return this.formatter.toRaw(this.$el.find('input[type="radio"]:checked').attr('value'), this.model);
#     },
#     render: function() {
#-      Backform.RadioControl.prototype.render.apply(this, arguments);
#+      var field = _.defaults(this.field.toJSON(), this.defaults),
#+        attributes = this.model.toJSON(),
#+        attrArr = field.name.split('.'),
#+        name = attrArr.shift(),
#+        path = attrArr.join('.'),
#+        rawValue = this.keyPathAccessor(attributes[name], path),
#+        data = _.extend(field, {
#+          rawValue: rawValue,
#+          value: this.formatter.fromRaw(rawValue, this.model),
#+          attributes: attributes,
#+          formatter: this.formatter,
#+        }),
#+        // Evaluate the disabled, visible, and required option
#+        evalF = function evalF(f, d, m) {
#+          return _.isFunction(f) ? !!f.apply(d, [m]) : !!f;
#+        };
#+
#+      _.extend(data, {
#+        disabled: evalF(data.disabled, data, this.model),
#+        visible: evalF(data.visible, data, this.model),
#+        required: evalF(data.required, data, this.model),
#+      }); // Clean up first
#+
#+      data.options = _.isFunction(data.options) ?
#+        data.options.apply(data, [this.model]) : data.options;
#+
#+      this.$el.removeClass(Backform.hiddenClassName);
#+      if (!data.visible) this.$el.addClass(Backform.hiddenClassName);
#+      this.$el.html(this.template(data)).addClass(field.name);
#+      this.updateInvalid();
#+
#       this.$el.find('.btn').on('keyup', (e)=>{
#         switch(e.keyCode) {
#         case 32: /* Spacebar click */
